
! DO-NOT-DELETE splicer.begin(_miscellaneous_code_start)
! Header files with short name definitions
! DO-NOT-DELETE splicer.end(_miscellaneous_code_start)

  ! DO-NOT-DELETE splicer.begin(functions.CubeFunction._ctor)
  ! Insert the implementation here...

  ! Access private data
  type(functions_CubeFunction_wrap) :: dp
  ! Allocate memory and initialize
  allocate(dp%d_private_data)
  call set_null(dp%d_private_data%frameworkServices)
  call functions_CubeFunction__set_data_m(self, dp)

  ! DO-NOT-DELETE splicer.end(functions.CubeFunction._ctor)


  ! DO-NOT-DELETE splicer.begin(functions.CubeFunction._dtor)
  ! Insert the implementation here...

  ! Access private data and deallocate storage
  type(functions_CubeFunction_wrap) :: dp
  call functions_CubeFunction__get_data_m(self, dp)

  ! Decrement reference count for framework services handle
  if (not_null(dp%d_private_data%frameworkServices)) then
     call deleteRef(dp%d_private_data%frameworkServices)
  end if

  deallocate(dp%d_private_data)

  ! DO-NOT-DELETE splicer.end(functions.CubeFunction._dtor)


  ! DO-NOT-DELETE splicer.begin(functions.CubeFunction.evaluate.use)
  ! Insert use statements here...
  use function_FunctionPort
  use gov_cca_Services
  use gov_cca_Port
  use sidl_BaseInterface
  use CubeFunction
  ! DO-NOT-DELETE splicer.end(functions.CubeFunction.evaluate.use)

  ! DO-NOT-DELETE splicer.begin(functions.CubeFunction.evaluate)
  ! Insert the implementation here...

  logical :: proceed

  type(SIDL_BaseInterface_t) :: excpt

  ! Private data reference
  type(functions_CubeFunction_wrap) :: dp

  ! Access private data
  call functions_CubeFunction__get_data_m(self, dp)

  proceed = .true.
  if (is_null(dp%d_private_data%frameworkServices)) then
    proceed = .false.
  end if

  ! Obtain handles to uses ports

  !
  ! Make call to legacy procedure
  !
  ! WARNING, call (and procedure) will have to change if there are uses ports
  !          The uses ports should be passed to the procedure and called there
  !          at the appropriate point
  !

  retval = evaluate_cube(x)

  !
  ! Cleanup (delete dangling references and release ports)
  !
  ! DO-NOT-DELETE splicer.end(functions.CubeFunction.evaluate)


  ! DO-NOT-DELETE splicer.begin(functions.CubeFunction.setServices.use)
  ! Insert use statements here...
  use gov_cca_TypeMap
  use gov_cca_Port
  ! DO-NOT-DELETE splicer.end(functions.CubeFunction.setServices.use)

  ! DO-NOT-DELETE splicer.begin(functions.CubeFunction.setServices)
  ! Insert the implementation here...

  character(len=*), parameter :: pn_FunctionPort = 'FunctionPort'
  character(len=*), parameter :: pt_FunctionPort = 'function.FunctionPort'

  type(gov_cca_TypeMap_t)     :: myTypeMap
  type(SIDL_BaseInterface_t)  :: excpt
  type(gov_cca_Port_t)        :: myPort

  ! Access private data
  type(functions_CubeFunction_wrap) :: dp
  call functions_CubeFunction__get_data_m(self, dp)

  ! Set my reference to the services handle
  dp%d_private_data%frameworkServices = services
  ! Increment reference count for the services subroutine parameter
  call addRef(services)

  ! Create a TypeMap with my properties
  call createTypeMap(services, myTypeMap, excpt)
  if (not_null(excpt)) then
    print *, "functions.CubeFunction Exception: in setServices call createTypeMap()"
    call deleteRef(excpt)
  end if
  call cast(self, myPort)

  !
  ! Add the provided ports
  !

  call addProvidesPort(services, myPort, pn_FunctionPort, &
                       pt_FunctionPort, myTypeMap, excpt)
  if (not_null(excpt)) then
    print *, "functions.CubeFunction Exception: in setServices call addProvidesPort('FunctionPort')"
    call deleteRef(excpt)
  end if

  !
  ! Register the used ports
  !


  call deleteRef(myTypeMap)

  ! DO-NOT-DELETE splicer.end(functions.CubeFunction.setServices)


! DO-NOT-DELETE splicer.begin(_miscellaneous_code_end)
! Insert extra code here...
! DO-NOT-DELETE splicer.end(_miscellaneous_code_end)
