module PiFunction

  interface evaluate
    module procedure evaluate_pi
  end interface evaluate

contains

function evaluate_pi(x)
  implicit none
  real(kind(1.0D0)) :: evaluate_pi
  real(kind(1.0D0)), intent(in) :: x
  evaluate_pi = 4.0 / (1.0 + x * x)
end function evaluate_pi

end module PiFunction
